#include <bits/stdc++.h>
using namespace std;
#define int long long
int t[10000000];
struct tree {
    void build(int v, int tl, int tr, const vector<int> &a) {
        if (tl + 1 == tr) {
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(2 * v, tl, tm, a);
        build(2 * v + 1, tm, tr, a);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
    int get(int v, int tl, int tr, int ql, int qr) {
        if (tl >= qr || ql >= tr) {
            return LLONG_MAX;
        }
        if (tl >= ql && tr <= qr) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return min(get(2 * v, tl, tm, ql, qr), get(2 * v + 1, tm, tr, ql, qr));
    }
};
int k2(int n, int k, vector<int> a) {
    vector<int> pref(n + 1);
    for (int i = 1; i < n + 1; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    int ans = 0;
    for (int i = 1; i < n; ++i) {
        ans = max(ans, abs(pref[i] - (pref[n] - pref[i])));
    }
    return ans;
}
int k3(int n, int k, vector<int> a) {
    vector<int> pref(n + 1);
    for (int i = 1; i < n + 1; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    int ans = 0;
    for (int i = 2; i <= n - 1; ++i) {
        int sum1 = pref[i - 1];
        int sum2 = pref[n] - pref[i];
        int x = a[i - 1];
        ans = max({ans, abs(sum1 - x), abs(sum2 - x), abs(sum1 - sum2)});
    }
    ans = max(ans, abs(min(a[0], a.back()) - (pref[n - 1] - pref[1])));
    return ans;
}
int n3000(int n, int k, vector<int> a) {
    if (n == k) {
        return *max_element(a.begin(), a.end()) - *min_element(a.begin(), a.end());
    }
    int len = n - k + 1;
    vector<int> pref(n + 1);
    for (int i = 1; i < n + 1; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    int where;
    int mx = -1;
    for (int i = 1; i < n + 1; ++i) {
        int start = max(0ll, i - len);
        if (pref[i] - pref[start] > mx) {
            where = start;
            mx = pref[i] - pref[start];
        }
    }
    int mn = LLONG_MAX;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        if (i == where) {
            for (int j = where;j < where + len; ++j) {
                sum += a[j];
            }
            i = where + len;
        }
        else {
            mn = min(mn, a[i]);
        }
    }
    int ans = sum - mn;
    len = n - k;
    vector<vector<int>> suka(n, vector<int>(3));
    vector<vector<int>> pizdec(n, vector<int>(3));
    suka[0] = {0,0,a[0]};
    pizdec[n - 1] = {n - 1, n - 1, a[n - 1]};
    deque<int> lol;
    lol.push_back(0);
    for (int i = 1; i < n; ++i) {
        while (!lol.empty() && lol.front() < i - len) {
            lol.pop_front();
        }
        int have = pref[lol.front()];
        if (pref[i + 1] - have > suka[i - 1][2]) {
            suka[i] = {lol.front(), i, pref[i + 1] - have};
        }
        else {
            suka[i] = suka[i - 1];
        }
        while (!lol.empty() && (pref[lol.back()] > pref[i] || lol.back() < i - len)) {
            lol.pop_back();
        }
        lol.push_back(i);
    }
    for (int i = n - 2; i >= 0; --i) {
        int j = min(n, i + len + 1);
        pizdec[i] = {i, j, pref[j] - pref[i]};
    }
    tree Tree;
    Tree.build(1, 0, n, a);
    for (int i = 0; i < n; ++i) {
        int l, r;
        int mx = 0;
        if (i > 0) {
            l = suka[i - 1][0];
            r = suka[i - 1][1];
            mx = suka[i - 1][2];
        }
        if (i + 1 < n) {
            if (pizdec[i + 1][2] > mx) {
                l = pizdec[i + 1][0];
                r = pizdec[i + 1][1];
                mx = pizdec[i + 1][2];
            }
        }
        // // cout << l << " " << r << " " << mx << endl;
        // // for (int j = i - 1; j >= 0; --j) {
        // //     int st = max(0ll, j - len);
        // //     if (pref[j + 1] - pref[st] > mx) {
        // //         mx = pref[j + 1] - pref[st];
        // //         l = st;
        // //         r = j;
        // //     }
        // // }
        // //cout << l << " " << r << " " << mx << endl;
        // for (int j = i + 1; j < n; ++j) {
        //     int fn = min(n, j + 1 + len);
        //     if (pref[fn] - pref[j] > mx) {
        //         mx = pref[fn] - pref[j];
        //         l = j;
        //         r = fn - 1;
        //     }
        // }
        int minim = min(Tree.get(1, 0, n, 0, l), Tree.get(1, 0, n, r + 1, n));
        ans = max(ans, mx - minim);
    }
    return ans;
}
signed main() {
    int n,k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (k == 2) {
        cout << k2(n, k, a) << endl;
        return 0;
    }
    if (k==3) {
        cout << k3(n, k, a) << endl;
        return 0;
    }
        cout << n3000(n,k,a) << endl;
        return 0;
        // int q;
        // cin >> q;
        // while (q--) {
        //     cout << q << "\n";
        //     int n,k;
        //     cin >> n >> k;
        //     vector<int> a(n);
        //     for (int i = 0; i < n; ++i) {
        //         cin >> a[i];
        //     }
        //     rec(a, LLONG_MAX, -LLONG_MAX, 1, k - 1, a[0], {});
        //     if (ans != n3000(n, k, a)) {
        //         cout << "FOUND\n";
        //         cout << ans << " " << n3000(n,k,a) << "\n";
        //         cout << n << " " << k << "\n";
        //         for (int p : a) {
        //             cout << p << " ";
        //         }
        //         for (int P : asd) {
        //             cout << P << " ";
        //         }
        //         cout << "\n";
        //         cout << "\n";
        //         return 0;
        //     }
        //     ans = 0;
        // }
    }